#ifndef __NDR_LSARPC_SCOMPAT_H__
#define __NDR_LSARPC_SCOMPAT_H__

struct pipes_struct;
struct dcesrv_endpoint_server;
struct dcesrv_call_state;

const struct dcesrv_endpoint_server *lsarpc_get_ep_server(void);

NTSTATUS lsarpc__op_ndr_pull(struct dcesrv_call_state *dce_call, TALLOC_CTX *mem_ctx, struct ndr_pull *pull, void **r);
struct lsa_Close;
NTSTATUS _lsa_Close(struct pipes_struct *p, struct lsa_Close *r);
struct lsa_Delete;
NTSTATUS _lsa_Delete(struct pipes_struct *p, struct lsa_Delete *r);
struct lsa_EnumPrivs;
NTSTATUS _lsa_EnumPrivs(struct pipes_struct *p, struct lsa_EnumPrivs *r);
struct lsa_QuerySecurity;
NTSTATUS _lsa_QuerySecurity(struct pipes_struct *p, struct lsa_QuerySecurity *r);
struct lsa_SetSecObj;
NTSTATUS _lsa_SetSecObj(struct pipes_struct *p, struct lsa_SetSecObj *r);
struct lsa_ChangePassword;
NTSTATUS _lsa_ChangePassword(struct pipes_struct *p, struct lsa_ChangePassword *r);
struct lsa_OpenPolicy;
NTSTATUS _lsa_OpenPolicy(struct pipes_struct *p, struct lsa_OpenPolicy *r);
struct lsa_QueryInfoPolicy;
NTSTATUS _lsa_QueryInfoPolicy(struct pipes_struct *p, struct lsa_QueryInfoPolicy *r);
struct lsa_SetInfoPolicy;
NTSTATUS _lsa_SetInfoPolicy(struct pipes_struct *p, struct lsa_SetInfoPolicy *r);
struct lsa_ClearAuditLog;
NTSTATUS _lsa_ClearAuditLog(struct pipes_struct *p, struct lsa_ClearAuditLog *r);
struct lsa_CreateAccount;
NTSTATUS _lsa_CreateAccount(struct pipes_struct *p, struct lsa_CreateAccount *r);
struct lsa_EnumAccounts;
NTSTATUS _lsa_EnumAccounts(struct pipes_struct *p, struct lsa_EnumAccounts *r);
struct lsa_CreateTrustedDomain;
NTSTATUS _lsa_CreateTrustedDomain(struct pipes_struct *p, struct lsa_CreateTrustedDomain *r);
struct lsa_EnumTrustDom;
NTSTATUS _lsa_EnumTrustDom(struct pipes_struct *p, struct lsa_EnumTrustDom *r);
struct lsa_LookupNames;
NTSTATUS _lsa_LookupNames(struct pipes_struct *p, struct lsa_LookupNames *r);
struct lsa_LookupSids;
NTSTATUS _lsa_LookupSids(struct pipes_struct *p, struct lsa_LookupSids *r);
struct lsa_CreateSecret;
NTSTATUS _lsa_CreateSecret(struct pipes_struct *p, struct lsa_CreateSecret *r);
struct lsa_OpenAccount;
NTSTATUS _lsa_OpenAccount(struct pipes_struct *p, struct lsa_OpenAccount *r);
struct lsa_EnumPrivsAccount;
NTSTATUS _lsa_EnumPrivsAccount(struct pipes_struct *p, struct lsa_EnumPrivsAccount *r);
struct lsa_AddPrivilegesToAccount;
NTSTATUS _lsa_AddPrivilegesToAccount(struct pipes_struct *p, struct lsa_AddPrivilegesToAccount *r);
struct lsa_RemovePrivilegesFromAccount;
NTSTATUS _lsa_RemovePrivilegesFromAccount(struct pipes_struct *p, struct lsa_RemovePrivilegesFromAccount *r);
struct lsa_GetQuotasForAccount;
NTSTATUS _lsa_GetQuotasForAccount(struct pipes_struct *p, struct lsa_GetQuotasForAccount *r);
struct lsa_SetQuotasForAccount;
NTSTATUS _lsa_SetQuotasForAccount(struct pipes_struct *p, struct lsa_SetQuotasForAccount *r);
struct lsa_GetSystemAccessAccount;
NTSTATUS _lsa_GetSystemAccessAccount(struct pipes_struct *p, struct lsa_GetSystemAccessAccount *r);
struct lsa_SetSystemAccessAccount;
NTSTATUS _lsa_SetSystemAccessAccount(struct pipes_struct *p, struct lsa_SetSystemAccessAccount *r);
struct lsa_OpenTrustedDomain;
NTSTATUS _lsa_OpenTrustedDomain(struct pipes_struct *p, struct lsa_OpenTrustedDomain *r);
struct lsa_QueryTrustedDomainInfo;
NTSTATUS _lsa_QueryTrustedDomainInfo(struct pipes_struct *p, struct lsa_QueryTrustedDomainInfo *r);
struct lsa_SetInformationTrustedDomain;
NTSTATUS _lsa_SetInformationTrustedDomain(struct pipes_struct *p, struct lsa_SetInformationTrustedDomain *r);
struct lsa_OpenSecret;
NTSTATUS _lsa_OpenSecret(struct pipes_struct *p, struct lsa_OpenSecret *r);
struct lsa_SetSecret;
NTSTATUS _lsa_SetSecret(struct pipes_struct *p, struct lsa_SetSecret *r);
struct lsa_QuerySecret;
NTSTATUS _lsa_QuerySecret(struct pipes_struct *p, struct lsa_QuerySecret *r);
struct lsa_LookupPrivValue;
NTSTATUS _lsa_LookupPrivValue(struct pipes_struct *p, struct lsa_LookupPrivValue *r);
struct lsa_LookupPrivName;
NTSTATUS _lsa_LookupPrivName(struct pipes_struct *p, struct lsa_LookupPrivName *r);
struct lsa_LookupPrivDisplayName;
NTSTATUS _lsa_LookupPrivDisplayName(struct pipes_struct *p, struct lsa_LookupPrivDisplayName *r);
struct lsa_DeleteObject;
NTSTATUS _lsa_DeleteObject(struct pipes_struct *p, struct lsa_DeleteObject *r);
struct lsa_EnumAccountsWithUserRight;
NTSTATUS _lsa_EnumAccountsWithUserRight(struct pipes_struct *p, struct lsa_EnumAccountsWithUserRight *r);
struct lsa_EnumAccountRights;
NTSTATUS _lsa_EnumAccountRights(struct pipes_struct *p, struct lsa_EnumAccountRights *r);
struct lsa_AddAccountRights;
NTSTATUS _lsa_AddAccountRights(struct pipes_struct *p, struct lsa_AddAccountRights *r);
struct lsa_RemoveAccountRights;
NTSTATUS _lsa_RemoveAccountRights(struct pipes_struct *p, struct lsa_RemoveAccountRights *r);
struct lsa_QueryTrustedDomainInfoBySid;
NTSTATUS _lsa_QueryTrustedDomainInfoBySid(struct pipes_struct *p, struct lsa_QueryTrustedDomainInfoBySid *r);
struct lsa_SetTrustedDomainInfo;
NTSTATUS _lsa_SetTrustedDomainInfo(struct pipes_struct *p, struct lsa_SetTrustedDomainInfo *r);
struct lsa_DeleteTrustedDomain;
NTSTATUS _lsa_DeleteTrustedDomain(struct pipes_struct *p, struct lsa_DeleteTrustedDomain *r);
struct lsa_StorePrivateData;
NTSTATUS _lsa_StorePrivateData(struct pipes_struct *p, struct lsa_StorePrivateData *r);
struct lsa_RetrievePrivateData;
NTSTATUS _lsa_RetrievePrivateData(struct pipes_struct *p, struct lsa_RetrievePrivateData *r);
struct lsa_OpenPolicy2;
NTSTATUS _lsa_OpenPolicy2(struct pipes_struct *p, struct lsa_OpenPolicy2 *r);
struct lsa_GetUserName;
NTSTATUS _lsa_GetUserName(struct pipes_struct *p, struct lsa_GetUserName *r);
struct lsa_QueryInfoPolicy2;
NTSTATUS _lsa_QueryInfoPolicy2(struct pipes_struct *p, struct lsa_QueryInfoPolicy2 *r);
struct lsa_SetInfoPolicy2;
NTSTATUS _lsa_SetInfoPolicy2(struct pipes_struct *p, struct lsa_SetInfoPolicy2 *r);
struct lsa_QueryTrustedDomainInfoByName;
NTSTATUS _lsa_QueryTrustedDomainInfoByName(struct pipes_struct *p, struct lsa_QueryTrustedDomainInfoByName *r);
struct lsa_SetTrustedDomainInfoByName;
NTSTATUS _lsa_SetTrustedDomainInfoByName(struct pipes_struct *p, struct lsa_SetTrustedDomainInfoByName *r);
struct lsa_EnumTrustedDomainsEx;
NTSTATUS _lsa_EnumTrustedDomainsEx(struct pipes_struct *p, struct lsa_EnumTrustedDomainsEx *r);
struct lsa_CreateTrustedDomainEx;
NTSTATUS _lsa_CreateTrustedDomainEx(struct pipes_struct *p, struct lsa_CreateTrustedDomainEx *r);
struct lsa_CloseTrustedDomainEx;
NTSTATUS _lsa_CloseTrustedDomainEx(struct pipes_struct *p, struct lsa_CloseTrustedDomainEx *r);
struct lsa_QueryDomainInformationPolicy;
NTSTATUS _lsa_QueryDomainInformationPolicy(struct pipes_struct *p, struct lsa_QueryDomainInformationPolicy *r);
struct lsa_SetDomainInformationPolicy;
NTSTATUS _lsa_SetDomainInformationPolicy(struct pipes_struct *p, struct lsa_SetDomainInformationPolicy *r);
struct lsa_OpenTrustedDomainByName;
NTSTATUS _lsa_OpenTrustedDomainByName(struct pipes_struct *p, struct lsa_OpenTrustedDomainByName *r);
struct lsa_TestCall;
NTSTATUS _lsa_TestCall(struct pipes_struct *p, struct lsa_TestCall *r);
struct lsa_LookupSids2;
NTSTATUS _lsa_LookupSids2(struct pipes_struct *p, struct lsa_LookupSids2 *r);
struct lsa_LookupNames2;
NTSTATUS _lsa_LookupNames2(struct pipes_struct *p, struct lsa_LookupNames2 *r);
struct lsa_CreateTrustedDomainEx2;
NTSTATUS _lsa_CreateTrustedDomainEx2(struct pipes_struct *p, struct lsa_CreateTrustedDomainEx2 *r);
struct lsa_CREDRWRITE;
NTSTATUS _lsa_CREDRWRITE(struct pipes_struct *p, struct lsa_CREDRWRITE *r);
struct lsa_CREDRREAD;
NTSTATUS _lsa_CREDRREAD(struct pipes_struct *p, struct lsa_CREDRREAD *r);
struct lsa_CREDRENUMERATE;
NTSTATUS _lsa_CREDRENUMERATE(struct pipes_struct *p, struct lsa_CREDRENUMERATE *r);
struct lsa_CREDRWRITEDOMAINCREDENTIALS;
NTSTATUS _lsa_CREDRWRITEDOMAINCREDENTIALS(struct pipes_struct *p, struct lsa_CREDRWRITEDOMAINCREDENTIALS *r);
struct lsa_CREDRREADDOMAINCREDENTIALS;
NTSTATUS _lsa_CREDRREADDOMAINCREDENTIALS(struct pipes_struct *p, struct lsa_CREDRREADDOMAINCREDENTIALS *r);
struct lsa_CREDRDELETE;
NTSTATUS _lsa_CREDRDELETE(struct pipes_struct *p, struct lsa_CREDRDELETE *r);
struct lsa_CREDRGETTARGETINFO;
NTSTATUS _lsa_CREDRGETTARGETINFO(struct pipes_struct *p, struct lsa_CREDRGETTARGETINFO *r);
struct lsa_CREDRPROFILELOADED;
NTSTATUS _lsa_CREDRPROFILELOADED(struct pipes_struct *p, struct lsa_CREDRPROFILELOADED *r);
struct lsa_LookupNames3;
NTSTATUS _lsa_LookupNames3(struct pipes_struct *p, struct lsa_LookupNames3 *r);
struct lsa_CREDRGETSESSIONTYPES;
NTSTATUS _lsa_CREDRGETSESSIONTYPES(struct pipes_struct *p, struct lsa_CREDRGETSESSIONTYPES *r);
struct lsa_LSARREGISTERAUDITEVENT;
NTSTATUS _lsa_LSARREGISTERAUDITEVENT(struct pipes_struct *p, struct lsa_LSARREGISTERAUDITEVENT *r);
struct lsa_LSARGENAUDITEVENT;
NTSTATUS _lsa_LSARGENAUDITEVENT(struct pipes_struct *p, struct lsa_LSARGENAUDITEVENT *r);
struct lsa_LSARUNREGISTERAUDITEVENT;
NTSTATUS _lsa_LSARUNREGISTERAUDITEVENT(struct pipes_struct *p, struct lsa_LSARUNREGISTERAUDITEVENT *r);
struct lsa_lsaRQueryForestTrustInformation;
NTSTATUS _lsa_lsaRQueryForestTrustInformation(struct pipes_struct *p, struct lsa_lsaRQueryForestTrustInformation *r);
struct lsa_lsaRSetForestTrustInformation;
NTSTATUS _lsa_lsaRSetForestTrustInformation(struct pipes_struct *p, struct lsa_lsaRSetForestTrustInformation *r);
struct lsa_CREDRRENAME;
NTSTATUS _lsa_CREDRRENAME(struct pipes_struct *p, struct lsa_CREDRRENAME *r);
struct lsa_LookupSids3;
NTSTATUS _lsa_LookupSids3(struct pipes_struct *p, struct lsa_LookupSids3 *r);
struct lsa_LookupNames4;
NTSTATUS _lsa_LookupNames4(struct pipes_struct *p, struct lsa_LookupNames4 *r);
struct lsa_LSAROPENPOLICYSCE;
NTSTATUS _lsa_LSAROPENPOLICYSCE(struct pipes_struct *p, struct lsa_LSAROPENPOLICYSCE *r);
struct lsa_LSARADTREGISTERSECURITYEVENTSOURCE;
NTSTATUS _lsa_LSARADTREGISTERSECURITYEVENTSOURCE(struct pipes_struct *p, struct lsa_LSARADTREGISTERSECURITYEVENTSOURCE *r);
struct lsa_LSARADTUNREGISTERSECURITYEVENTSOURCE;
NTSTATUS _lsa_LSARADTUNREGISTERSECURITYEVENTSOURCE(struct pipes_struct *p, struct lsa_LSARADTUNREGISTERSECURITYEVENTSOURCE *r);
struct lsa_LSARADTREPORTSECURITYEVENT;
NTSTATUS _lsa_LSARADTREPORTSECURITYEVENT(struct pipes_struct *p, struct lsa_LSARADTREPORTSECURITYEVENT *r);
struct lsa_Opnum82NotUsedOnWire;
void _lsa_Opnum82NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum82NotUsedOnWire *r);
struct lsa_Opnum83NotUsedOnWire;
void _lsa_Opnum83NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum83NotUsedOnWire *r);
struct lsa_Opnum84NotUsedOnWire;
void _lsa_Opnum84NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum84NotUsedOnWire *r);
struct lsa_Opnum85NotUsedOnWire;
void _lsa_Opnum85NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum85NotUsedOnWire *r);
struct lsa_Opnum86NotUsedOnWire;
void _lsa_Opnum86NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum86NotUsedOnWire *r);
struct lsa_Opnum87NotUsedOnWire;
void _lsa_Opnum87NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum87NotUsedOnWire *r);
struct lsa_Opnum88NotUsedOnWire;
void _lsa_Opnum88NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum88NotUsedOnWire *r);
struct lsa_Opnum89NotUsedOnWire;
void _lsa_Opnum89NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum89NotUsedOnWire *r);
struct lsa_Opnum90NotUsedOnWire;
void _lsa_Opnum90NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum90NotUsedOnWire *r);
struct lsa_Opnum91NotUsedOnWire;
void _lsa_Opnum91NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum91NotUsedOnWire *r);
struct lsa_Opnum92NotUsedOnWire;
void _lsa_Opnum92NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum92NotUsedOnWire *r);
struct lsa_Opnum93NotUsedOnWire;
void _lsa_Opnum93NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum93NotUsedOnWire *r);
struct lsa_Opnum94NotUsedOnWire;
void _lsa_Opnum94NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum94NotUsedOnWire *r);
struct lsa_Opnum95NotUsedOnWire;
void _lsa_Opnum95NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum95NotUsedOnWire *r);
struct lsa_Opnum96NotUsedOnWire;
void _lsa_Opnum96NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum96NotUsedOnWire *r);
struct lsa_Opnum97NotUsedOnWire;
void _lsa_Opnum97NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum97NotUsedOnWire *r);
struct lsa_Opnum98NotUsedOnWire;
void _lsa_Opnum98NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum98NotUsedOnWire *r);
struct lsa_Opnum99NotUsedOnWire;
void _lsa_Opnum99NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum99NotUsedOnWire *r);
struct lsa_Opnum100NotUsedOnWire;
void _lsa_Opnum100NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum100NotUsedOnWire *r);
struct lsa_Opnum101NotUsedOnWire;
void _lsa_Opnum101NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum101NotUsedOnWire *r);
struct lsa_Opnum102NotUsedOnWire;
void _lsa_Opnum102NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum102NotUsedOnWire *r);
struct lsa_Opnum103NotUsedOnWire;
void _lsa_Opnum103NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum103NotUsedOnWire *r);
struct lsa_Opnum104NotUsedOnWire;
void _lsa_Opnum104NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum104NotUsedOnWire *r);
struct lsa_Opnum105NotUsedOnWire;
void _lsa_Opnum105NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum105NotUsedOnWire *r);
struct lsa_Opnum106NotUsedOnWire;
void _lsa_Opnum106NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum106NotUsedOnWire *r);
struct lsa_Opnum107NotUsedOnWire;
void _lsa_Opnum107NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum107NotUsedOnWire *r);
struct lsa_Opnum108NotUsedOnWire;
void _lsa_Opnum108NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum108NotUsedOnWire *r);
struct lsa_Opnum109NotUsedOnWire;
void _lsa_Opnum109NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum109NotUsedOnWire *r);
struct lsa_Opnum110NotUsedOnWire;
void _lsa_Opnum110NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum110NotUsedOnWire *r);
struct lsa_Opnum111NotUsedOnWire;
void _lsa_Opnum111NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum111NotUsedOnWire *r);
struct lsa_Opnum112NotUsedOnWire;
void _lsa_Opnum112NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum112NotUsedOnWire *r);
struct lsa_Opnum113NotUsedOnWire;
void _lsa_Opnum113NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum113NotUsedOnWire *r);
struct lsa_Opnum114NotUsedOnWire;
void _lsa_Opnum114NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum114NotUsedOnWire *r);
struct lsa_Opnum115NotUsedOnWire;
void _lsa_Opnum115NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum115NotUsedOnWire *r);
struct lsa_Opnum116NotUsedOnWire;
void _lsa_Opnum116NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum116NotUsedOnWire *r);
struct lsa_Opnum117NotUsedOnWire;
void _lsa_Opnum117NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum117NotUsedOnWire *r);
struct lsa_Opnum118NotUsedOnWire;
void _lsa_Opnum118NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum118NotUsedOnWire *r);
struct lsa_Opnum119NotUsedOnWire;
void _lsa_Opnum119NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum119NotUsedOnWire *r);
struct lsa_Opnum120NotUsedOnWire;
void _lsa_Opnum120NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum120NotUsedOnWire *r);
struct lsa_Opnum121NotUsedOnWire;
void _lsa_Opnum121NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum121NotUsedOnWire *r);
struct lsa_Opnum122NotUsedOnWire;
void _lsa_Opnum122NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum122NotUsedOnWire *r);
struct lsa_Opnum123NotUsedOnWire;
void _lsa_Opnum123NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum123NotUsedOnWire *r);
struct lsa_Opnum124NotUsedOnWire;
void _lsa_Opnum124NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum124NotUsedOnWire *r);
struct lsa_Opnum125NotUsedOnWire;
void _lsa_Opnum125NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum125NotUsedOnWire *r);
struct lsa_Opnum126NotUsedOnWire;
void _lsa_Opnum126NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum126NotUsedOnWire *r);
struct lsa_Opnum127NotUsedOnWire;
void _lsa_Opnum127NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum127NotUsedOnWire *r);
struct lsa_Opnum128NotUsedOnWire;
void _lsa_Opnum128NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum128NotUsedOnWire *r);
struct lsa_CreateTrustedDomainEx3;
NTSTATUS _lsa_CreateTrustedDomainEx3(struct pipes_struct *p, struct lsa_CreateTrustedDomainEx3 *r);
struct lsa_OpenPolicy3;
NTSTATUS _lsa_OpenPolicy3(struct pipes_struct *p, struct lsa_OpenPolicy3 *r);
struct lsa_Opnum131NotUsedOnWire;
void _lsa_Opnum131NotUsedOnWire(struct pipes_struct *p, struct lsa_Opnum131NotUsedOnWire *r);
struct lsa_lsaRQueryForestTrustInformation2;
NTSTATUS _lsa_lsaRQueryForestTrustInformation2(struct pipes_struct *p, struct lsa_lsaRQueryForestTrustInformation2 *r);
struct lsa_lsaRSetForestTrustInformation2;
NTSTATUS _lsa_lsaRSetForestTrustInformation2(struct pipes_struct *p, struct lsa_lsaRSetForestTrustInformation2 *r);
NTSTATUS lsarpc__op_dispatch(struct dcesrv_call_state *dce_call, TALLOC_CTX *mem_ctx, void *r);
NTSTATUS lsarpc__op_reply(struct dcesrv_call_state *dce_call, TALLOC_CTX *mem_ctx, void *r);
NTSTATUS lsarpc__op_ndr_push(struct dcesrv_call_state *dce_call, TALLOC_CTX *mem_ctx, struct ndr_push *push, const void *r);
NTSTATUS lsarpc__op_local(struct dcesrv_call_state *dce_call, TALLOC_CTX *mem_ctx, void *r);
#endif /* __NDR_LSARPC_SCOMPAT_H__ */
